Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# BamCache Class Reference

This class maintains a cache of Bam and/or Txo objects generated from model files and texture images (as well as possibly other kinds of loadable objects that can be stored in bam file format). More...

List of all members.

## Public Member Functions
| BamCache ()
| considerFlushIndex ()
| Flushes the index if enough time has elapsed since the index was last flushed.
| flushIndex ()
| Ensures the index is written to disk.
bool | getActive ()
| Returns true if the BamCache is currently active, false if it is not.
bool | getCacheCompressedTextures ()
| Returns whether compressed texture files will be stored in the cache, as compressed txo files.
int | getCacheMaxKbytes ()
| Returns the maximum size, in kilobytes, which the cache is allowed to grow to.
bool | getCacheModels ()
| Returns whether model files (e.g.
bool | getCacheTextures ()
| Returns whether texture files (e.g.
int | getFlushTime ()
| Returns the time in seconds between automatic flushes of the cache index.
bool | getReadOnly ()
| Returns true if the cache is in read-only mode.
Filename | getRoot ()
| Returns the current root pathname of the cache.
BamCacheRecord | lookup (Filename const source_filename, string cache_extension)
| Looks up a file in the cache.
| setActive (bool flag)
| Changes the state of the active flag.
| setCacheCompressedTextures (bool flag)
| Indicates whether compressed texture files will be stored in the cache, as compressed txo files.
| setCacheMaxKbytes (int max_kbytes)
| Specifies the maximum size, in kilobytes, which the cache is allowed to grow to.
| setCacheModels (bool flag)
| Indicates whether model files (e.g.
| setCacheTextures (bool flag)
| Indicates whether texture files will be stored in the cache, as uncompressed txo files.
| setFlushTime (int flush_time)
| Specifies the time in seconds between automatic flushes of the cache index.
| setReadOnly (bool ro)
| Can be used to put the cache in read-only mode, or take it out of read-only mode.
| setRoot (Filename const root)
| Changes the current root pathname of the cache.
bool | store (BamCacheRecord record)
| Flushes a cache entry to disk.
## Static Public Member Functions
static BamCache | getGlobalPtr ()
| Returns a pointer to the global BamCache object, which is used automatically by the ModelPool and TexturePool.

## Detailed Description

This class maintains a cache of Bam and/or Txo objects generated from model files and texture images (as well as possibly other kinds of loadable objects that can be stored in bam file format).

This class also maintains a persistent index that lists all of the cached objects (see BamCacheIndex). We go through some considerable effort to make sure this index gets saved correctly to disk, even in the presence of multiple different processes writing to the same index, and without relying too heavily on low-level os-provided file locks (which work poorly with C++ iostreams).

## Constructor & Destructor Documentation

BamCache | ( |  | ) |

## Member Function Documentation

considerFlushIndex | ( |  | ) |

Flushes the index if enough time has elapsed since the index was last flushed.

flushIndex | ( |  | ) |

Ensures the index is written to disk.

bool getActive | ( |  | ) |

Returns true if the BamCache is currently active, false if it is not.

"active" means that the cache should be consulted automatically on loads, "not active" means that objects should be loaded directly without consulting the cache.

This represents the global flag. Also see the individual cache_models, cache_textures, cache_compressed_textures flags.

bool getCacheCompressedTextures | ( |  | ) |

Returns whether compressed texture files will be stored in the cache, as compressed txo files.

See set_cache_compressed_textures().

This also returns false if get_active() is false.

int getCacheMaxKbytes | ( |  | ) |

Returns the maximum size, in kilobytes, which the cache is allowed to grow to.

See set_cache_max_kbytes().

bool getCacheModels | ( |  | ) |

Returns whether model files (e.g.

egg files and bam files) will be stored in the cache, as bam files.

This also returns false if get_active() is false.

bool getCacheTextures | ( |  | ) |

Returns whether texture files (e.g.

egg files and bam files) will be stored in the cache, as txo files.

This also returns false if get_active() is false.

int getFlushTime | ( |  | ) |

Returns the time in seconds between automatic flushes of the cache index.

static BamCache getGlobalPtr | ( |  | ) | `[static]`

Returns a pointer to the global BamCache object, which is used automatically by the ModelPool and TexturePool.

bool getReadOnly | ( |  | ) |

Returns true if the cache is in read-only mode.

Normally, the cache starts in read-write mode. It can put itself into read-only mode automatically if it discovers that it does not have write access to the cache.

Filename getRoot | ( |  | ) |

Returns the current root pathname of the cache.

See set_root().

BamCacheRecord lookup | ( | Filename const | source_filename,
|  | string | cache_extension
| ) |  |

Looks up a file in the cache.

If the file is cacheable, then regardless of whether the file is found in the cache or not, this returns a BamCacheRecord. On the other hand, if the file cannot be cached, returns NULL.

If record->has_data() returns true, then the file was found in the cache, and you may call record->extract_data() to get the object. If record->has_data() returns false, then the file was not found in the cache or the cache was stale; and you should reload the source file (calling record->add_dependent_file() for each file loaded, including the original source file), and then call record->set_data() to record the resulting loaded object; and finally, you should call store() to write the cached record to disk.

setActive | ( | bool | flag | ) |

Changes the state of the active flag.

"active" means that the cache should be consulted automatically on loads, "not active" means that objects should be loaded directly without consulting the cache.

This represents the global flag. Also see the individual cache_models, cache_textures, cache_compressed_textures flags.

setCacheCompressedTextures | ( | bool | flag | ) |

Indicates whether compressed texture files will be stored in the cache, as compressed txo files.

The compressed data may either be generated in-CPU, via the squish library, or it may be extracted from the GSG after the texture has been loaded.

This may be set in conjunction with set_cache_textures(), or independently of it. If set_cache_textures() is true and this is false, all textures will be cached in their uncompressed form. If set_cache_textures() is false and this is true, only compressed textures will be cached, and they will be cached in their compressed form. If both are true, all textures will be cached, in their uncompressed or compressed form appropriately.

setCacheMaxKbytes | ( | int | max_kbytes | ) |

Specifies the maximum size, in kilobytes, which the cache is allowed to grow to.

If a newly cached file would exceed this size, an older file is removed from the cache.

Note that in the case of multiple different processes simultaneously operating on the same cache directory, the actual cache size may slightly exceed this value from time to time due to latency in checking between the processes.

setCacheModels | ( | bool | flag | ) |

Indicates whether model files (e.g.

egg files and bam files) will be stored in the cache, as bam files.

setCacheTextures | ( | bool | flag | ) |

Indicates whether texture files will be stored in the cache, as uncompressed txo files.

setFlushTime | ( | int | flush_time | ) |

Specifies the time in seconds between automatic flushes of the cache index.

setReadOnly | ( | bool | ro | ) |

Can be used to put the cache in read-only mode, or take it out of read-only mode.

Note that if you put it into read-write mode, and it discovers that it does not have write access, it will put itself right back into read-only mode.

setRoot | ( | Filename const | root | ) |

Changes the current root pathname of the cache.

This specifies where the cache files are stored on disk. This should name a directory that is on a disk local to the machine (not on a network-mounted disk), for instance, /tmp/panda-cache or /c/panda-cache.

If the directory does not already exist, it will be created as a result of this call.

bool store | ( | BamCacheRecord | record | ) |

Flushes a cache entry to disk.

You must have retrieved the cache record via a prior call to lookup(), and then stored the data via record->set_data(). Returns true on success, false on failure.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties